﻿using System;
using System.Linq;
using System.Windows.Forms;
using System.Collections.Generic;

/*                  Backpropagation with the Iris data set                       */
/*                    test program using the soft max function                   */
/*                       www.mosismath.com                                       */

namespace WindowsFormsApplication1
{
   
    public partial class Mainwin : Form
    {

        int samples = 29;
        int dataLength = 0;
        const int features = 4;
        int layers = 1;
        
        TData data = new TData();
        List<TLayer> net = new List<TLayer>();
  
        public Mainwin()
        {
            int i,j;
            DataGridViewCell cell;
            TLayer actLayer;

            InitializeComponent();
            data.readData(Application.StartupPath + "\\data_iris_test.csv");

            actLayer = new TLayer(4, 3);
            actLayer.InitSigmoid();
            net.Add(actLayer);

            actLayer = new TLayer(3, 3);
            actLayer.InitSigmoid();
            net.Add(actLayer);

            actLayer = new TLayer(3, 3);
            actLayer.InitSoftMax();
            net.Add(actLayer);

            layers = net.Count;

           /* actLayer = net.ElementAt(0); // initialisation for testing soft max 
            actLayer.w[0, 0] = -0.44075237288339875;
            actLayer.w[0, 1] = -0.44075237288339875;
            actLayer.w[0, 2] = -0.44075237288339875;

            actLayer.w[1, 0] = -0.66858610035234745;
            actLayer.w[1, 1] = -0.66858610035234745;
            actLayer.w[1, 2] = -0.66858610035234745;

            actLayer.w[2, 0] = 1.2118400374353389;
            actLayer.w[2, 1] = 1.2118400374353389;
            actLayer.w[2, 2] = 1.2118400374353389;

            actLayer.w[3, 0] = 1.3881603111446867;
            actLayer.w[3, 1] = 1.3881603111446867;
            actLayer.w[3, 2] = 1.3881603111446867;

            actLayer.offs[0] = -3.0482269046710697;
            actLayer.offs[1] = -3.0482269046710697;
            actLayer.offs[2] = -3.0482269046710697;

            actLayer = net.ElementAt(1);
            actLayer.w[0, 0] = -3.2276519660691778;
            actLayer.w[0, 1] = 4.0973445654045646;
            actLayer.w[0, 2] = 4.52036957515863;

            actLayer.w[1, 0] = -3.2276519660691778;
            actLayer.w[1, 1] = 4.0973445654045646;
            actLayer.w[1, 2] = 4.52036957515863;

            actLayer.w[2, 0] = -3.2276519660691778;
            actLayer.w[2, 1] = 4.0973445654045646;
            actLayer.w[2, 2] = 4.52036957515863;

            actLayer.offs[0] = 2.1004525576851414;
            actLayer.offs[1] = -0.69233397042199307;
            actLayer.offs[2] = -7.4525565636154445;

            actLayer = net.ElementAt(2);
            actLayer.w[0, 0] = 11.149428740323163;
            actLayer.w[0, 1] = 1.1544067850629958;
            actLayer.w[0, 2] = -3.3198627622278529;

            actLayer.w[1, 0] = 0.094022598673881269;
            actLayer.w[1, 1] = 12.179744907815254;
            actLayer.w[1, 2] = -2.4582625308099662;

            actLayer.w[2, 0] = -1.7122307105004175;
            actLayer.w[2, 1] = -5.4903560200221095;
            actLayer.w[2, 2] = 13.910652251888944;

            actLayer.offs[0] = 0;
            actLayer.offs[1] = 0;
            actLayer.offs[2] = 0;*/

            actLayer = net.ElementAt(0); // initialisation for testing cross entropy
            actLayer.w[0, 0] = -0.23082971371493866;
            actLayer.w[0, 1] = -0.23082971371493866;
            actLayer.w[0, 2] = -0.23082971371493866;

            actLayer.w[1, 0] = -0.643574715497329;
            actLayer.w[1, 1] = -0.643574715497329;
            actLayer.w[1, 2] = -0.643574715497329;

            actLayer.w[2, 0] = 0.7620115216706117;
            actLayer.w[2, 1] = 0.7620115216706117;
            actLayer.w[2, 2] = 0.7620115216706117;

            actLayer.w[3, 0] = 1.611255930233525;
            actLayer.w[3, 1] = 1.611255930233525;
            actLayer.w[3, 2] = 1.611255930233525;

            actLayer.offs[0] = -2.1120952240313309;
            actLayer.offs[1] = -2.1120952240313309;
            actLayer.offs[2] = -2.1120952240313309;

            actLayer = net.ElementAt(1);
            actLayer.w[0, 0] = -6.248315538226116;
            actLayer.w[0, 1] = 5.1171150969740449;
            actLayer.w[0, 2] = 4.5729256970515122;

            actLayer.w[1, 0] = -6.248315538226116;
            actLayer.w[1, 1] = 5.1171150969740449;
            actLayer.w[1, 2] = 4.5729256970515122;

            actLayer.w[2, 0] = -6.248315538226116;
            actLayer.w[2, 1] = 5.1171150969740449;
            actLayer.w[2, 2] = 4.5729256970515122;

            actLayer.offs[0] = 3.6868287313884975;
            actLayer.offs[1] = -5.4332717165485143;
            actLayer.offs[2] = -9.43613225651258;

            actLayer = net.ElementAt(2);
            actLayer.w[0, 0] = 6.3486409752452575;
            actLayer.w[0, 1] = -0.30680999152577709;
            actLayer.w[0, 2] = -4.5418309837193913;

            actLayer.w[1, 0] = -8.9841768446647343;
            actLayer.w[1, 1] = 11.317087157669494;
            actLayer.w[1, 2] = -0.83291031300434648;

            actLayer.w[2, 0] = -4.42523943290456;
            actLayer.w[2, 1] = -6.1418078730471519;
            actLayer.w[2, 2] = 12.067047305951723;
            actLayer.offs[0] = 0;
            actLayer.offs[1] = 0;
            actLayer.offs[2] = 0;

            samples = data.values.Count;
            dataLength = data.dataLength;
            dgDataView.RowCount = samples;
            dgDataView.ColumnCount = 8;

            dgDataView.Columns[0].HeaderText = "x1";
            dgDataView.Columns[1].HeaderText = "x2";
            dgDataView.Columns[2].HeaderText = "x3";
            dgDataView.Columns[3].HeaderText = "x4";
            dgDataView.Columns[4].HeaderText = "y";
            dgDataView.Columns[5].HeaderText = "Class";
            dgDataView.Columns[6].HeaderText = "dev[%]";

            for (i = 0; i < samples; i++)
            {
                dgDataView.Rows[i].HeaderCell.Value = (i + 1).ToString();
                for (j = 0; j <= features; j++)
                {
                    cell = dgDataView[j, i];
                    cell.Value = Math.Round(data.values.ElementAt(i)[j], 4).ToString();
                }
            }
        }


        private double[] ForwardProp(double[] x)
        {
            int i, j, k;
            TLayer actLayer = net.ElementAt(0);
            double[] actX = new double[x.Length];
            for (i = 0; i < x.Length; i++)
            {
                actX[i] = x[i];
            }
            actLayer.calcSum = true;
            for (i = 0; i < layers - 1; i++)
            {
                for (j = 0; j < actLayer.featuresOut; j++)
                {
                    actLayer.x[j] = actLayer.offs[j];
                    for (k = 0; k < actLayer.featuresIn; k++)
                    {
                        actLayer.x[j] = actLayer.x[j] + actX[k] * actLayer.w[k, j];
                    }
                    actLayer.o[j] = actLayer.Act(actLayer.x[j]);
                }

                for (j = 0; j < actLayer.x.Length; j++)
                {
                    actX[j] = actLayer.o[j];
                }

                actLayer = net.ElementAt(i + 1);
            }
            // last layer
            for (j = 0; j < actLayer.featuresOut; j++)
            {
                actLayer.x[j] = 0;
                for (k = 0; k < actLayer.featuresIn; k++)
                {
                    actLayer.x[j] = actLayer.x[j] + actLayer.w[k, j] * actX[k];
                }
            }

            double enumerator = 0;
            for (j = 0; j < actLayer.featuresOut; j++)
            {
                enumerator = enumerator + Math.Exp(actLayer.x[j]);
            }
            for (j = 0; j < actLayer.featuresOut; j++)
            {
                actLayer.o[j] = Math.Exp(actLayer.x[j]) / enumerator;
            }

            return actLayer.o;
        }


        private void bt_Calc_Click(object sender, EventArgs e)
        {
            int i, j, k;
            double[] res;
            double[] tempX = new double[features];
            DataGridViewCell cell;
            TLayer actLayer = net.ElementAt(0);
            // print data
            for (i = 0; i < samples; i++)
            {
                for (k = 0; k < features; k++)
                {
                    tempX[k] = data.values.ElementAt(i)[k];
                }
                res = ForwardProp(tempX);
                cell = dgDataView[5, i];
                cell.Value = Math.Round(res[0], 4).ToString();
                cell = dgDataView[6, i];
                cell.Value = Math.Round(res[1], 4).ToString();
                cell = dgDataView[7, i];
                cell.Value = Math.Round(res[2], 4).ToString();

                cell = dgDataView[5, i];
                if ((res[0] > 0.5) && (res[1] < 0.5) && (res[2] < 0.5))
                {
                    cell.Value = "Iris-setosa";
                }
                else
                {
                    if ((res[0] < 0.5) && (res[1] > 0.5) && (res[2] < 0.5))
                    {
                        cell.Value = "Iris-versicolor";
                    }
                    else
                    {
                        cell.Value = "Iris_virginica";
                    }
                }

                double tempRes = 0;
                if (res[0] < 0.5)
                    tempRes = tempRes + (1 - res[0]) * (1 - res[0]);
                else
                    tempRes = tempRes + res[0] * res[0];
                if (res[1] < 0.5)
                    tempRes = tempRes + (1 - res[1]) * (1 - res[1]);
                else
                    tempRes = tempRes + res[1] * res[1];
                if (res[2] < 0.5)
                    tempRes = tempRes + (1 - res[2]) * (1 - res[2]);
                else
                    tempRes = tempRes + res[2] * res[2];

                cell = dgDataView[6, i];
                cell.Value = Math.Round(Math.Sqrt(tempRes / 3) * 100, 4).ToString();
            }
        }
    }
}
